
class AnalisadorParedes():
	def __init__(self,fantasma):
		self.fantasma = fantasma
		#na ordem, [dir atras, esq atras, dir frente, esq frente]
		self.distanciaAnterior = [-1,-1,-1,-1]
		self.distanciaAtual = [-1,-1,-1,-1]
		self.pontos = [-1,-1,-1,-1]
		self.epsylon = 0.3
		self.estadoAtual = [False, False, False, False]
		self.podeVirar = [False, False]

	def zeraDistancias(self):
		for i in range (0,4):
			self.distanciaAnterior[i] = -1
			self.estadoAtual[i] = False
		for i in range (0,2):
			self.podeVirar[i] = False

	def inverteDistancias(self):
		self.troca(0,3)
		self.troca(1,2)

		temp = self.podeVirar[0]
		self.podeVirar[0] = self.podeVirar[1]
		self.podeVirar[1] = temp

	def troca(self,i,j):
		tempEstado = self.estadoAtual[i]
		self.estadoAtual[i] = self.estadoAtual[j]
		self.estadoAtual[j] = tempEstado

		tempDistAnterior = self.distanciaAnterior[i]
		self.distanciaAnterior[i] = self.distanciaAnterior[j]
		self.distanciaAnterior[j] = tempDistAnterior

		tempDistAtual = self.distanciaAtual[i]
		self.distanciaAtual[i] = self.distanciaAtual[j]
		self.distanciaAtual[j] = tempDistAtual

	def pertoDaParede(self,maisPerto):
		if self.fantasma.ultimoMov == 'c' or self.fantasma.ultimoMov == 'b':
			ptoOndeEstaParede = maisPerto.getSurfacePoint(maisPerto.getIntoNodePath()).getY()
			ptoFantasma = self.fantasma.node.getY()
		else:
			ptoOndeEstaParede = maisPerto.getSurfacePoint(maisPerto.getIntoNodePath()).getX()
			ptoFantasma = self.fantasma.node.getX()

		distAtual = abs(ptoOndeEstaParede - ptoFantasma)

		if distAtual < 0.5: 
			return True
		return False
		

	def existeEntrada(self,paredes):

		#calcula pontos
		if self.fantasma.ultimoMov == 'c' or self.fantasma.ultimoMov == 'b':
			for i in range (0,4):
				self.pontos[i] = paredes[i].getSurfacePoint(paredes[i].getIntoNodePath()).getX() 		 
			ptoFantasma = self.fantasma.node.getX()
		else:
			for i in range (0,4):
				self.pontos[i] = paredes[i].getSurfacePoint(paredes[i].getIntoNodePath()).getY() 		 
			ptoFantasma = self.fantasma.node.getY()

		#calcula distancia atual
		for i in range (0,4):
			self.distanciaAtual[i] = abs(self.pontos[i] - ptoFantasma)

		# se dist anterior is -1, apenas atualiza as distancias
		if self.distanciaAnterior[0] == -1:

			for i in range (0,4):
				if self.distanciaAtual[i] > 10:
					self.estadoAtual[i] = True

			#atualiza as distancias
			for i in range (0,4):
				self.distanciaAnterior[i] = self.distanciaAtual[i]

			self.verificaEstados()

		else:
			self.recalculaDistancias()

			#atualiza as distancias
			for i in range (0,4):
				self.distanciaAnterior[i] = self.distanciaAtual[i]

			self.verificaEstados()
			

	def verificaEstados(self):
		#verifica se estados atuais estao corretos
		if self.estadoAtual[0] == True and self.estadoAtual[2] == True:
			self.podeVirar[0] = True
		else:
			self.podeVirar[0] = False
		if self.estadoAtual[1] == True and self.estadoAtual[3] == True:
			self.podeVirar[1] = True
		else:
			self.podeVirar[1] = False

	def trocaEstado(self,i):
		if self.estadoAtual[i] == True:
			self.estadoAtual[i] = False
		else:
			self.estadoAtual[i] = True

	def recalculaDistancias(self):
		for i in range (0,4):
			if abs(self.distanciaAnterior[i] - self.distanciaAtual[i]) > self.epsylon:
				self.trocaEstado(i)

	def imprimeDados(self):
		s = ""
		for i in range (0,4):
			s = str(s + str(self.estadoAtual[i]) + " ") 	
		print str( "ESTADOS " + s)


