import random

class Sensor():
	def __init__(self):
		self.listaDeAcoes = dict()
		self.totalDePontos = 0		

	def adicionaNaLista(self,acao):
		self.listaDeAcoes[acao.nome] = acao
		self.totalDePontos += acao.score

	def atribuiProbabilidades(self):
		limiteInferior = 0
		limiteSuperior = 0

		for nome, acao in self.listaDeAcoes.iteritems():
			limiteInferior = limiteSuperior + 1
			limiteSuperior += acao.score
			acao.probabilidade = acao.score/self.totalDePontos
			acao.intervaloMin = limiteInferior
			acao.intervaloMax = limiteSuperior

	def sorteiaAcao(self):
		acaoSorteada = None

		numEscolhido = random.randrange(1,int(self.totalDePontos)+1)
		for nome, acao in self.listaDeAcoes.iteritems():
			if numEscolhido >= acao.intervaloMin and numEscolhido <= acao.intervaloMax:
				acaoSorteada = acao
				break

		return acaoSorteada.nome
